/** 
*/

#ifndef CCOMPONENT_DATA_H
#define CCOMPONENT_DATA_H

/* SYSTEM INCLUDES */

/* PROJECT INCLUDES */


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class CStaticNode;

#ifdef __cplusplus
extern "C" 
{
#endif
    /****************** BEGIN OLD STYLE C spesific ********/
    
    
    /****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class CComponentData : public IComponentData, IExtendPropertySheet2
{
    friend class CComponent;
    
public:
    // LIFECYCLE
    CComponentData();
    ~CComponentData();
    
    // OPERATORS
    // OPERATIONS
    
    STDMETHODIMP QueryInterface(REFIID riid, LPVOID *ppv);
    STDMETHODIMP_(ULONG) AddRef();
    STDMETHODIMP_(ULONG) Release();
    
    virtual HRESULT STDMETHODCALLTYPE Initialize( 
    /* [in] */ LPUNKNOWN pUnknown);
        
    virtual HRESULT STDMETHODCALLTYPE CreateComponent( 
    /* [out] */ LPCOMPONENT __RPC_FAR *ppComponent);
        
    virtual /* [helpstring] */ HRESULT STDMETHODCALLTYPE Notify( 
    /* [in] */ LPDATAOBJECT lpDataObject,
    /* [in] */ MMC_NOTIFY_TYPE event,
    /* [in] */ LPARAM arg,
    /* [in] */ LPARAM param);
        
    virtual HRESULT STDMETHODCALLTYPE Destroy( void);
    
    virtual HRESULT STDMETHODCALLTYPE QueryDataObject( 
    /* [in] */ MMC_COOKIE cookie,
    /* [in] */ DATA_OBJECT_TYPES type,
    /* [out] */ LPDATAOBJECT __RPC_FAR *ppDataObject);
        
        
    virtual HRESULT STDMETHODCALLTYPE GetDisplayInfo( 
    /* [out][in] */ SCOPEDATAITEM __RPC_FAR *pScopeDataItem);
           
    virtual HRESULT STDMETHODCALLTYPE CompareObjects( 
    /* [in] */ LPDATAOBJECT lpDataObjectA,
    /* [in] */ LPDATAOBJECT lpDataObjectB);
        
    //////////////////////////////////
    // Interface IExtendPropertySheet2
    //////////////////////////////////
       
    virtual HRESULT STDMETHODCALLTYPE CreatePropertyPages( 
    /* [in] */ LPPROPERTYSHEETCALLBACK lpProvider,
    /* [in] */ LONG_PTR handle,
    /* [in] */ LPDATAOBJECT lpIDataObject);
        
    virtual HRESULT STDMETHODCALLTYPE QueryPagesFor( 
    /* [in] */ LPDATAOBJECT lpDataObject);
        
    virtual HRESULT STDMETHODCALLTYPE GetWatermarks( 
    /* [in] */ LPDATAOBJECT lpIDataObject,
    /* [out] */ HBITMAP __RPC_FAR *lphWatermark,
    /* [out] */ HBITMAP __RPC_FAR *lphHeader,
    /* [out] */ HPALETTE __RPC_FAR *lphPalette,
    /* [out] */ BOOL __RPC_FAR *bStretch);
        
    // CALLBACK
    // ACCESS
    // INQUIRY
        
protected:
private:
    ULONG m_cref;
    LPCONSOLE m_ipConsole;
    LPCONSOLENAMESPACE m_ipConsoleNameSpace;
    
    CStaticNode *m_pStaticNode;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* CCOMPONENT_DATA_H_ */

