#include "StdAfx.h"
#include "WarMmcSnapin.h"
#include "WmsNodeCurrentActivity.h"   // class implemented
#include "WarCollector.h"
#include "WarIfServer.h"


/////////////////////////////// PUBLIC ///////////////////////////////////////

// {EEAFC8C5-9476-4d7e-864C-3BF151395619}
const GUID WmsNodeCurrentActivity::thisGuid = 
{ 0xeeafc8c5, 0x9476, 0x4d7e, { 0x86, 0x4c, 0x3b, 0xf1, 0x51, 0x39, 0x56, 0x19 } };


WmsNodeCurrentActivity::WmsNodeCurrentActivity(war_if_server_ptr_t& rSvrPtr)
: mServicePtr(rSvrPtr) // Deleted by parent
{
}

WmsNodeCurrentActivity::~WmsNodeCurrentActivity()
{
}

//============================= LIFECYCLE ====================================
//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= CALLBACK     ===================================

HRESULT WmsNodeCurrentActivity::OnExpand(IConsoleNameSpace *pConsoleNameSpace, 
                                 IConsole *pConsole, 
                                 HSCOPEITEM parent)
{
    if (GetHandle() == NULL) 
        SetHandle((HANDLE)parent);

    if (!bExpanded) 
    {
    }
 
    return S_OK;   
}

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

const int WmsNodeCurrentActivity::GetBitmapIndex()
{
    return NICON_CURRACT;
}

const _TCHAR *WmsNodeCurrentActivity::GetDisplayName(int nCol)
{
    static _TCHAR szDisplayName[256] = {0};
    
    if (!*szDisplayName)
    {
        LoadString(g_hinst, 
            IDS_CURRACTNAME, 
            szDisplayName, 
            sizeof(szDisplayName));
    }
    
    return szDisplayName; 
}

const GUID & WmsNodeCurrentActivity::getNodeType()
{
    return thisGuid; 
}

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

