/** 
*/

#ifndef WMS_NODE_SERVERS_FOLDER_H
#define WMS_NODE_SERVERS_FOLDER_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef CDELEGATION_BASE_H
#   include "DelegationBase.h"
#endif

#ifndef WAR_IF_SERVER_H
#   include "WarIfServer.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class WarIfServer;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WmsNodeServersFolder : public CDelegationBase
{
public:
    // LIFECYCLE

    WmsNodeServersFolder(war_if_server_ptr_t& rSvrPtr);
    ~WmsNodeServersFolder();

    // OPERATORS
    // OPERATIONS
    // CALLBACK

    virtual HRESULT OnExpand(IConsoleNameSpace *pConsoleNameSpace, IConsole *pConsole, HSCOPEITEM parent);
    virtual HRESULT OnShow(IConsole *pConsole, BOOL bShow, HSCOPEITEM scopeitem);

    // ACCESS
    // INQUIRY

    virtual const int GetBitmapIndex();
    virtual const _TCHAR *GetDisplayName(int nCol = 0);
    virtual const GUID& getNodeType();
 
protected:
private:
    war_if_server_ptr_t mServicePtr;
    static const GUID thisGuid;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WMS_NODE_SERVERS_FOLDER_H_ */

