#include "StdAfx.h"
#include "WarMmcSnapin.h"
#include "WmsNodeTransferLogs.h"   // class implemented
#include "WarCollector.h"
#include "WarIfServer.h"



/////////////////////////////// PUBLIC ///////////////////////////////////////


// {32903653-86C7-4d4f-9BD2-BDDFCB08B695}
const GUID WmsNodeTransferLogs::thisGuid = 
{ 0x32903653, 0x86c7, 0x4d4f, { 0x9b, 0xd2, 0xbd, 0xdf, 0xcb, 0x8, 0xb6, 0x95 } };


WmsNodeTransferLogs::WmsNodeTransferLogs(war_if_site_ptr_t& rSitePtr)
: mSitePtr(rSitePtr) // Deleted by parent
{
}

WmsNodeTransferLogs::~WmsNodeTransferLogs()
{
}

//============================= LIFECYCLE ====================================
//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= CALLBACK     ===================================

HRESULT WmsNodeTransferLogs::OnExpand(IConsoleNameSpace *pConsoleNameSpace, 
                                 IConsole *pConsole, 
                                 HSCOPEITEM parent)
{
    if (GetHandle() == NULL) 
        SetHandle((HANDLE)parent);

    if (!bExpanded) 
    {
        
    }
 
    return S_OK;   
}

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

const int WmsNodeTransferLogs::GetBitmapIndex()
{
    return NICON_SITE_LOG;
}

const _TCHAR *WmsNodeTransferLogs::GetDisplayName(int nCol)
{
    static _TCHAR szDisplayName[256] = {0};
    
    if (!*szDisplayName)
    {
        LoadString(g_hinst, 
            IDS_NODE_TRANSFER_LOGS, 
            szDisplayName, 
            sizeof(szDisplayName));
    }
    
    return szDisplayName; 
}

const GUID & WmsNodeTransferLogs::getNodeType()
{
    return thisGuid; 
}

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

