/** 
*/

#ifndef WMS_NODE_USER_H
#define WMS_NODE_USER_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef CDELEGATION_BASE_H
#   include "DelegationBase.h"
#endif

#ifndef WAR_IF_USER_H
#   include "WarIfUser.h"
#endif


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class WarIfServer;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WmsNodeUser : public CDelegationBase
{
public:
    // LIFECYCLE

    WmsNodeUser(war_if_user_ptr_t& rUserPtr);
    ~WmsNodeUser();

    // OPERATORS
    // OPERATIONS
    // CALLBACK

    virtual HRESULT CreatePropertyPages(IPropertySheetCallback *lpProvider, LONG_PTR handle);
    virtual HRESULT HasPropertySheets() { return S_OK; }
    virtual HRESULT OnSelect(IConsole *pConsole, BOOL bScope, BOOL bSelect);

    // ACCESS
    // INQUIRY

    virtual const int GetBitmapIndex();
    virtual const _TCHAR *GetDisplayName(int nCol = 0);
    virtual const GUID& getNodeType();
    
protected:
private:
    war_if_user_ptr_t mUserPtr;
    static const GUID thisGuid;

};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WMS_NODE_USER_H_ */

