#include "StdAfx.h"
#include "WarCriticalSection.h"   // class implemented
#include <assert.h>

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

WarCriticalSection::WarCriticalSection(bool allowRecursive)
    : mDoRecursive(allowRecursive)
#ifdef _DEBUG
    , mNumLocks(0)
#endif
{
    ::InitializeCriticalSection(&mHandle);
}// WarCriticalSection


WarCriticalSection::~WarCriticalSection()
{
#ifdef _DEBUG
    assert(mNumLocks == 0);
#endif
    ::DeleteCriticalSection(&mHandle);
}// ~WarCriticalSection


//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================


//============================= ACESS      ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

