#include "StdAfx.h"
#include "WarOptionWin32.h"   // class implemented

#ifndef WAR_OPTION_LIST_H
#   include "WarOptionList.h"
#endif

#define AUTO_LOCK WarAutoLock my_lock((WarCriticalSection &)mLock);

/////////////////////////////// PUBLIC ///////////////////////////////////////


WarWin32Registry& operator >> (WarWin32Registry& o, 
                               WarOptionList& ops)
{
    WarWin32Registry::keyname_list_t keys;
    o.EnumValue(keys);

    for(WarWin32Registry::keyname_list_t::const_iterator P = keys.begin()
        ; P != keys.end()
        ; P++)
    {
        WarCollector<char> name(*P);
        WarOptionList::iterator PP = ops.find(name.GetValue());
        if (PP != ops.end())
            ops.erase(PP);

        ops.insert(war_option_pair_t(name.GetValue(), 
            WarOption(WarCollector<char>(o.GetStrValue(P->c_str())).GetValue())));
    }

    return o;
}



//============================= LIFECYCLE ====================================
//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////
/////////////////////////////// PRIVATE    ///////////////////////////////////

