#include "StdAfx.h"
#include "WarPerfmonMap.h"   // class implemented
#include <tchar.h>

///////////////////////////////////////////////////////////////////////////////

CPrfData* CPrfData::sm_pPrfData = NULL;

PRFDATA_MAP_BEGIN()

PRFDATA_MAP_OBJ(WAR_PRFOBJ_SVR, L"WFDE Server", 
    L"Current activity in the server ",
    PERF_DETAIL_NOVICE, WAR_PRFSVR_USERS_ONLINE, PERF_NO_INSTANCES, 0)

    PRFDATA_MAP_CTR(WAR_PRFSVR_USERS_ONLINE,  L"Users Online",  
        L"The number of users currently logged on",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_RAWCOUNT)

    PRFDATA_MAP_CTR(WAR_PRFSVR_TRANSFERS_NOW,  L"Current transfers",  
        L"The number of current transfers",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_RAWCOUNT)

    PRFDATA_MAP_CTR(WAR_PRFSVR_TRANSFERS_TOTAL,  L"Total transfers",  
        L"The total number of successful transfers",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_RAWCOUNT)

    PRFDATA_MAP_CTR(WAR_PRFSVR_TRANSFERS_FAILED,  L"Failed transfers",  
        L"The total number of failed/cancelled transfers",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_RAWCOUNT)

    PRFDATA_MAP_CTR(WAR_PRFSVR_KPS_OUT,  L"Current kbytes/sec out",  
        L"The current kbytes/sec out rate",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_COUNTER)

    PRFDATA_MAP_CTR(WAR_PRFSVR_KPS_IN,  L"Current kbytes/sec in",  
        L"The current kbytes/sec out rate",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_COUNTER)

#ifdef _DEBUG

PRFDATA_MAP_OBJ(WAR_PRFOBJ_DEBUG, L"WFDE Debug", 
    L"Debugging aid ",
    PERF_DETAIL_NOVICE, WAR_PRFSVR_USERS_ONLINE, PERF_NO_INSTANCES, 0)

    PRFDATA_MAP_CTR(WAR_PRFDEBUG_NUM_AUTOPTR,  L"Autopointers",  
        L"The current kbytes/sec out rate",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_RAWCOUNT)

    PRFDATA_MAP_CTR(WAR_PRFDEBUG_NUM_OPEN_SOCKETS,  L"Open sockets",  
        L"Number of open sockets",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_RAWCOUNT)

    PRFDATA_MAP_CTR(WAR_PRFDEBUG_NUM_SOCKETS,  L"Socket objects",  
        L"Number of socket objects",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_RAWCOUNT)

    PRFDATA_MAP_CTR(WAR_PRFDEBUG_NUM_SOCKET_IO,  L"Socket IO objects",  
        L"Number of socket IO objects",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_RAWCOUNT)

    PRFDATA_MAP_CTR(WAR_PRFDEBUG_NUM_OPEN_FILES,  L"Open files",  
        L"Number of open files objects",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_RAWCOUNT)

    PRFDATA_MAP_CTR(WAR_PRFDEBUG_NUM_FILES,  L"File objects",  
        L"Number of files objects",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_RAWCOUNT)

    PRFDATA_MAP_CTR(WAR_PRFDEBUG_NUM_FTPCTL,  L"FTP control conn. obj.",  
        L"Number of files objects",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_RAWCOUNT)

    PRFDATA_MAP_CTR(WAR_PRFDEBUG_NUM_FTPDATA,  L"FTP data conn. obj.",  
        L"Number of files objects",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_RAWCOUNT)
        
    PRFDATA_MAP_CTR(WAR_PRFDEBUG_NUM_SCKPENDINGIO,  L"Socket pending IO",  
        L"Number of pending IO callback/IOCP calls on sockets",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_RAWCOUNT)

    PRFDATA_MAP_CTR(WAR_PRFDEBUG_NUM_FILEPENDINGIO,  L"File pending IO",  
        L"Number of pending IO callback/IOCP calls on files",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_RAWCOUNT)

    PRFDATA_MAP_CTR(WAR_PRFDEBUG_NUM_SCKCONNPNDIO,  L"Socket pending conn. IO",
        L"Number of pending IO callback/IOCP calls on files",  
        PERF_DETAIL_NOVICE, 0, PERF_COUNTER_RAWCOUNT)


#endif // _DEBUG
  
PRFDATA_MAP_END(WAR_PERFMON_NAME)

