#include "StdAfx.h"
#include "WarSvrEngineSocket.h"   // class implemented

#ifndef WAR_SVR_ENGINE_SOCKET_H
#   include "WarSvrEngineSocket.h"
#endif

#ifndef WAR_SVR_ENGINE_H
#   include "WarSvrEngine.h"
#endif


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

WarSvrEngineSocket::WarSvrEngineSocket(WarSvrEngine *pEngine,
                                       war_svrdef_ptr_t& svrDefPtr,
                                       war_socket_io_ptr_t& companionPtr)
: WarSocket(companionPtr), 
mSvrDefPtr(svrDefPtr),
mpEngine(pEngine)
{
}// WarSvrEngineSocket


WarSvrEngineSocket::~WarSvrEngineSocket()
{
}// ~WarSvrEngineSocket


//============================= OPERATORS ====================================


//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

void WarSvrEngineSocket::OnAccept(const WarError& status,
                                  war_socket_t newSocket,
                                  const WarNetAddress& remoteAddress,
                                  const WarNetAddress& localAddress)
{
    mpEngine->OnAccept(status, 
        newSocket,
        remoteAddress, 
        localAddress,
        this);
}

/////////////////////////////// PRIVATE    ///////////////////////////////////

