#include "StdAfx.h"
#include "WarUserAuth.h"   // class implemented
#include <time.h>

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

WarUserAuth::WarUserAuth()
{
}// WarUserAuth


WarUserAuth::~WarUserAuth()
{
}// ~WarUserAuth


//============================= OPERATORS ====================================

WarCollector<char> WarUserAuth::GeneratePasswd(unsigned pwdLength)
{
    WarCollector<char> key(WarCollector<char>::SM_ERASE);

    srand(time(NULL));
    unsigned i = 0;
	int r = 0;
    char ch = 0;

    if (pwdLength)
    {
        for(i = 0; i < pwdLength; i++)
        {
            while(true)
            {
                ch = (char)(rand() & 0x7f);
                
                if (isalnum(ch) && !strchr("10lOI", ch))
                    break;
            }
            
            key << (char) ch;
        }
    }
    else // How 1.70 did it...
    {
        
        for(i = 0; i < 2; i++)
        {
            do
            {
                r = rand();
            }	while(!isalpha(r & 0xff));
            key << (char) tolower((char)(r & 0xff));
        }
        
        for(i = 2; i < 4; i++)
        {
            do
            {
                r = rand();
            }	while(!isdigit(r & 0xff));
            key << (char) (char)(r & 0xff);
        }
        
        for(i = 4; i < 7; i++)
        {
            do
            {
                r = rand();
            }	while(!isalpha(r & 0xff));
            key << (char) tolower((char)(r & 0xff));
        }
    }

    return key;
}

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

