/** 
*/

#ifndef WAR_ARGS_H
#define WAR_ARGS_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

template <class charT>
class WarArgs 
{
public:
    typedef std::vector<charT *> args_t;
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarArgs(void)
        : mArgMode(false)
    {
    }
    
    /**
    * Destructor.
    */
    ~WarArgs(void)
    {
        for(int i = 0; i < mArgs.size(); i++)
        {
            delete mArgs[i];
            mArgs[i] = NULL;
        }
    }
    
    // OPERATORS
    // OPERATIONS                       

    void Add(const charT *arg)
    {
        const charT *p = arg;
        size_t lenght = 0;
        while(*p)
        {
            ++p;
            ++lenght;
        }

        charT *buffer = new charT[lenght +1];
        if (lenght)
            memcpy(buffer, arg, lenght);
        buffer[lenght] = 0;

        mArgs.push_back(buffer);
    }

    // ACCESS

    int GetArgc() const
    {
        return mArgs.size();
    }

    char **GetArgv()
    {
        return &mArgs[0];
    }

    // INQUIRY

    bool mArgMode; // Only split at whitespace _if_ the token looks like a command-line argument
protected:
private:
    args_t mArgs;
};



/* INLINE METHODS */

template <class charT>
WarArgs<charT>& operator << (WarArgs<charT>& to, const charT *from)
{
    std::basic_string<charT> buf;

    const charT *p = from;
    if (p) do
    {
        buf.erase();
        while(*p)
        {
            if (isspace(*p))
            {
                if (to.mArgMode)
                {
                    if ((buf.size() > 1) 
                        && (buf[0] == '-')
                        && ((isalpha(buf[2])
                        || (buf == std::string("--")))))
                        goto break_up;
                }
                else
                {
break_up:
                    while(isspace(*p))
                        ++p;
                    break;
                }
            }
            buf += *p++;
        }
        
        if (!buf.empty())
            to.Add(buf.c_str());
    } while(*p);

    return to;
}

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_ARGS_H_ */

