/** 
*/

#ifndef WAR_IF_PATH_LIST_H
#define WAR_IF_PATH_LIST_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_WIN32_REGISTRY_H
#   include "WarWin32Registry.h"
#endif

#ifndef WAR_SVR_PATH_H
#   include "WarSvrPath.h"
#endif

#ifndef WAR_IP_ACCESS_LIST_H
#   include "WarIpAccessList.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarIfPathList 
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarIfPathList(const WarWin32Registry& regKey);
    
    /**
    * Destructor.
    */
    ~WarIfPathList();
    
    // OPERATORS
    // OPERATIONS

    void EnumPaths(war_svr_pathset_t& pathSet, 
        bool doReplace = true)
        throw(WarException);

    // CALLBACK
    // ACCESS
    // INQUIRY
protected:
private:
    WarWin32Registry mRegKey;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_IF_PATH_LIST_H_ */

