/** 
*/

#ifndef WAR_LOG_THREAD_H
#define WAR_LOG_THREAD_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_THREAD_H
#   include "WarThread.h"
#endif

#ifndef WAR_WARLOG_EVENT_H
#   include "WarLogEvent.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class WarLogEngine;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarLogThread :
public WarThread
{
public:
    typedef std::list<war_logevent_ptr_t> log_list_t;
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarLogThread();
    
    // OPERATORS
    
    /**
    * Assignment operator.
    *
    * @param from THe value to assign to this object.
    *
    * @return A reference to this object.
    */
    WarLogThread& operator=(WarLogThread& from);
    
    // OPERATIONS

    void PushEvent(war_logevent_ptr_t& logEventPtr);

    // CALLBACK
    // ACCESS
    // INQUIRY
    
protected:
    ~WarLogThread();

    static void OnShutdown(war_cptr_t parg);

private:
    virtual void Run();
    WarThreadEvent mEvent;
    log_list_t mLogEvents;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_LOG_THREAD_H_ */

