/** 
*/

#ifndef WAR_OS_H
#define WAR_OS_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_EXCEPTION
#   include "WarException.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarOs 
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarOs(void) throw(WarException);
    
    /**
    * Destructor.
    */
    ~WarOs(void);
    
    // OPERATORS
    
    
    // OPERATIONS                       
    // ACCESS

    static WarOs& GetOs() throw(WarException)
    {
        if (!mspThis)
            WarThrow(WarError(WAR_ERR_INTERNAL_DATA_NOT_INITIALIZED), NULL);

        return *mspThis;
    }

    // INQUIRY

    bool IsNt() const;
    
    std::string GetOsName() const;
   
protected:
private:
#ifdef WIN32
    OSVERSIONINFO mOsInfo;
#endif
    static WarOs *mspThis;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#define WarIsNt() (WarOs::GetOs().IsNt())

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_OS_H_ */

