/** 
*/

#ifndef WAR_SVR_DIRLIST_H
#define WAR_SVR_DIRLIST_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_DIRLIST_H
#   include "WarDirList.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class WarSvrProtocol;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarSvrDirList : public WarDirList
{
public:
    // LIFECYCLE

    WarSvrDirList(const war_uint32_t flags,
        const WarSvrProtocol& currentServer,
        bool doVerifyForList = true);

    // OPERATORS
    // OPERATIONS
    
    void Create(war_ccstr_t dirPath)
        throw (WarException);

    void AddMountPoints(const WarSvrPath& SvrPath)
        throw (WarException);

    // ACCESS

    inline const WarSvrPath& GetSvrPath() const
    {
        return mResolvedPath;
    }

    // INQUIRY
    /** Return the visual path to the directory, 
    relative to the users CWD */
    inline const war_svrpath_t& GetRelativePath() const
    {
        return mRelativePath;
    }
    
protected:
    const WarSvrProtocol& mrCurrentServer;
    war_svrpath_t mRelativePath;
    WarSvrPath mResolvedPath;
    bool mDoVerifyForList;

private:
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_SVR_DIRLIST_H_ */

