/** 
*/

#ifndef WAR_SVR_PROTOCOL_FTP_MSGS_H
#define WAR_SVR_PROTOCOL_FTP_MSGS_H

/* SYSTEM INCLUDES */

#ifndef WAR_VECTOR_INCLUDED
#   define WAR_VECTOR_INCLUDED
#   include <vector>
#endif

#ifndef WAR_IOSTREAM_INCLUDED
#   define WAR_IOSTREAM_INCLUDED
#   include <iostream>
#endif

/* PROJECT INCLUDES */

#ifndef WAR_TYPES_H
#   include "WarTypes.h"
#endif

#ifndef WAR_SVR_PROTOCOL_FTP_ENUMS_H
#   include "WarSvrProtocolFtpEnums.h"
#endif

#ifndef WAR_EXCEPTION_H
#   include "WarException.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarSvrProtocolFtpMsgs : public WarSvrProtocolFtpEnums
{
public:
    typedef std::vector<std::string> strings_t;

    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarSvrProtocolFtpMsgs(void);

    
    WarSvrProtocolFtpMsgs(const WarSvrProtocolFtpMsgs& from);
     
    // OPERATORS

    war_ccstr_t operator [] (int Index) const throw(WarException);
    const WarSvrProtocolFtpMsgs& operator = (const WarSvrProtocolFtpMsgs& from);

    friend std::ostream& operator << (std::ostream& Out, const WarSvrProtocolFtpMsgs& from);
    friend std::istream& operator >> (std::istream& In, WarSvrProtocolFtpMsgs& from);
    
    // OPERATIONS                       
    // ACCESS

    FtpSvrMsgsE GetIndex(war_ccstr_t MacroName) const ;

    // INQUIRY
    
protected:
private:
    strings_t mStrMsg;
    static const war_ccstr_t msDefMsg[SM_INVALID +1];
    static const war_ccstr_t msMacroName[SM_INVALID +1];
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_SVR_PROTOCOL_FTP_MSGS_H_ */

