/** 
  
   WarThreadPoolTask that process I/O Completion ports.
*/

#ifndef WAR_SVR_WIN32_NT_ENGINE_TASK_H
#define WAR_SVR_WIN32_NT_ENGINE_TASK_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_THREAD_POOL_TASK_H
#   include"WarThreadPoolTask.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */


class WarSvrWin32NtEngine;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarSvrWin32NtEngineTask : public WarThreadPoolTask
{
public:

    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarSvrWin32NtEngineTask(WarSvrWin32NtEngine& rEngine);
   
    /**
    * Destructor.
    */
    ~WarSvrWin32NtEngineTask(void);
    
    // OPERATORS
    
    
    // OPERATIONS                       
    // ACCESS
    // INQUIRY

    /// Housekeeping delay
    DWORD GetWaitTimeout() 
    {
        return 1000;
    }
    
protected:
    virtual void OnProcessing(WarThreadForPool * pThread);

private:
    WarSvrWin32NtEngine& mrEngine;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_SVR_WIN32_NTENGINE_TASK_H_ */

