/** 
*/

#ifndef WAR_THREAD_FOR_POOL_H
#define WAR_THREAD_FOR_POOL_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_THREAD_H
#   include "WarThread.h"
#endif

#ifndef WAR_AUTO_REF_H
#   include "WarAutoRef.h"
#endif

#ifndef WAR_AUTO_COUNTER_H
#   include "WarAutoCounter.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class WarThreadPool;
class WarThreadPoolTask;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarThreadForPool : public WarThread
{
public:
    // LIFECYCLE
    
     WarThreadForPool(WarThreadPool * pPool);
    
    // OPERATIONS
    // ACCESS
    // INQUIRY
    
protected:
    virtual void Run();
    virtual void ProcessRequest(WarThreadPoolTask * pTask);
    virtual ~WarThreadForPool();
private:
    WarThreadPool* mpPool;
    WarAutoCounter<int> mAutoCnt;
    
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_THREAD_FOR_POOL_H_ */

