/** 
*/

#ifndef WAR_TIMER_GENERIC_EVENT_H
#define WAR_TIMER_GENERIC_EVENT_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_TIMER_EVENT_H
#   include "WarTimerEvent.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

template <class classT, class ptrT = WarPtrWrapper<classT> >
class WarTimerGenericEvent 
: public WarTimerEvent
{
public:
    // LIFECYCLE
    typedef ptrT origin_ptr_t;
    
    /**
    * Default constructor.
    */
    WarTimerGenericEvent(
        classT *originPtr,
        const WarTime& timerWhen,
        TimerTypeE timerType = TIMER_ONCE, 
        const timer_delay_t timerDelayMs = 0,
        const bool IsFast = false)
        : WarTimerEvent(timerWhen, timerType, timerDelayMs, IsFast),
        mOriginPtr(originPtr)
    {
    }
    
    // OPERATORS
    // OPERATIONS                       
    // ACCESS
    // INQUIRY
    
protected:
    origin_ptr_t mOriginPtr;

    virtual void OnTimer()
    {
        mOriginPtr->OnTimer();
    }

private:
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_TIMER_GENERIC_EVENT_H_ */

