/** 
*/

#ifndef WAR_MMC_NODE_NT_USER_H
#define WAR_MMC_NODE_NT_USER_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_MMC_BASE_NODE_H
#   include "WarMmcBaseNode.h"
#endif

#ifndef WAR_USER_AUTHDATA_WIN32_NT_H
#   include "WarUserAuthDataWin32Nt.h"
#endif

#ifndef WAR_MMC_NODE_SHARES_H
#   include "WarMmcNodeShares.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarMmcNodeNtUser 
: public WarMmcBaseNode<WarMmcNodeNtUser> 
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarMmcNodeNtUser(war_authdata_ptr_t& userPtr)
        : mUserPtr(&(*userPtr))
    {
        m_bstrDisplayName = userPtr->GetUserName().c_str(); 
    }
    
     /**
    * Destructor.
    */
    ~WarMmcNodeNtUser(void) {}
    
    // OPERATORS
    
    // OPERATIONS                       

    virtual HRESULT OnExpand(BOOL bExpand, IConsole *pConsole, HSCOPEITEM parent) 
	{   
        if (bExpand)
        {
            CComQIPtr<IConsoleNameSpace, 
                &IID_IConsoleNameSpace> 
                spConsoleNameSpace(pConsole);

            WarUserAuthDataWin32Nt& my_user 
                = (WarUserAuthDataWin32Nt&)(*mUserPtr);

            // Show shares
            SCOPEDATAITEM sdi;
            memset(&sdi, 0, sizeof(sdi));
            sdi.mask = SDI_STR | SDI_PARAM | SDI_IMAGE | SDI_OPENIMAGE | SDI_PARENT;
            sdi.displayname = MMC_CALLBACK;
            sdi.relativeID = parent;
            sdi.nImage = WAR_IL_SHARED_FOLDER;
            sdi.nOpenImage = WAR_IL_SHARED_FOLDER_OPEN;
            sdi.lParam = (LPARAM)new WarMmcNodeShares(
                my_user.GetRegRoot().GetPath(WAR_WINNT_REG_FILE_SYSTEMS));
            spConsoleNameSpace->InsertItem(&sdi);

            // Show options
            
        }
        return S_OK; 
    }


    // ACCESS
    // INQUIRY
    
protected:
private:
    war_authdata_ptr_t mUserPtr;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_MMC_NODE_FTP_SERVERS_H_ */

