/** 
*/

#ifndef WAR_MMC_NODE_SHARES_H
#define WAR_MMC_NODE_SHARES_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_MMC_BASE_NODE_H
#   include "WarMmcBaseNode.h"
#endif

#ifndef WAR_MMC_NODE_FILE_SHARE_H
# include "WarMmcNodeFileShare.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus


class WarMmcNodeShares 
: public WarMmcBaseNode<WarMmcNodeShares>,
public WarMmcNodeEventBase
{
public:
    // LIFECYCLE
    typedef std::list<WarMmcNodeFileShare *> share_t;
    share_t mShares;
    
    /**
    * Default constructor.
    */
    WarMmcNodeShares(const war_registrypath_t& regNode);
    
     /**
    * Destructor.
    */
    ~WarMmcNodeShares(void);
    
    // OPERATORS

    void EnumerateChildren();
    void FreeShares();

    // MMC
    SNAPINMENUID(IDR_WARSVRSNAPIN_MENU);

    BEGIN_SNAPINCOMMAND_MAP(CNodeB, FALSE)
		SNAPINCOMMAND_ENTRY(ID_NEW_SHARE, InvokeNewWizzard)
	END_SNAPINCOMMAND_MAP()

    HRESULT InvokeNewWizzard(bool& bHandled, CSnapInObjectRootBase* pObj);

    STDMETHOD(QueryPagesFor)(DATA_OBJECT_TYPES type);
    
    // OPERATIONS
    
    STDMETHOD(CreatePropertyPages)(
        LPPROPERTYSHEETCALLBACK lpProvider,
        long handle, 
        IUnknown* pUnk,
        DATA_OBJECT_TYPES type);


    virtual HRESULT OnExpand(BOOL bExpand, IConsole *pConsole, HSCOPEITEM parent);
	
    HRESULT OnShow(IConsole *pConsole, BOOL bShow);

    virtual HRESULT OnPropertyPageApplied(
        WarMmcFuckLameMicrosoftForNotImplementingThis *pfrom);

    virtual HRESULT OnChange(IConsole* pConsole, LPARAM data, LONG_PTR hint);

    // ACCESS
    // INQUIRY
    
    bool mDoEnumerate;
protected:
private:
    WarWin32Registry mRegKey;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_MMC_NODE_FTP_SERVERS_H_ */

