
#include "stdafx.h"
#include <assert.h>

#include <iostream>

#include "WarPath.h"
#include "WarUtf8.h"
#include "WarUrl.h"

using namespace std;

void TestWarUrl()
{
    WarUrl my_url;
    
    my_url.Create("ftp://", 
        "jgaa",
        "secret",
        2121,
        "ftp.jgaa.com",
        "devel/test/file.txt",
        "TYPE A");

    cout << "FTP url: '" 
        << my_url.GetUrl()
        << "'"
        << endl;

    WarUrl parsed_url;
        parsed_url = my_url.GetUrl();

    if (parsed_url.GetUrl() == my_url.GetUrl())
        cout << "Url comparsion OK" << endl;
    else
        cout << "Url comparsion FAILED" << endl;

    WarUrl file_url_one("file:///test.file");
    cout << "File url one's path is '" 
        << WarUtf8(file_url_one.GetFilePath().GetPath()).GetUtf8()
        << '\'' 
        << endl;

    WarUrl file_url_two("file:////dir1/dir2/test.file");
    cout << "File url two's path is '" 
        << WarUtf8(file_url_two.GetFilePath().GetPath()).GetUtf8()
        << '\'' 
        << endl;

    cout << "file_url_one's mount path is '" 
        << WarUtf8(file_url_one.GetFilePath().GetMountPath().GetPath()).GetUtf8()
        << '\'' 
        << endl;
}

