#include "StdAfx.h"
#include "WarSvrProtocolFtpLite.h"   // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

WarSvrProtocolFtpLite::WarSvrProtocolFtpLite(
    war_socket_io_ptr_t& companionPtr,
    WarSvrDefinition& svrDefinion)
: WarSvrProtocolFtp(companionPtr, svrDefinion)
{

    // Override some macros with our own stuff
    mReply.InstallMacro(war_macro_ptr_t(new MacroProgramnameLite()), true);
    mReply.InstallMacro(war_macro_ptr_t(new MacroProgramversionLite()), true);
    mReply.InstallMacro(war_macro_ptr_t(new MacroPrgcopyrightLite()), true);       
    mReply.InstallMacro(war_macro_ptr_t(new MacroBuilddateLite()), true);       
}



//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

