#if !defined(AFX_PROPPAGELOGMODULE_H__9B03085A_360C_4477_9EA2_CACE129AA2C8__INCLUDED_)
#define AFX_PROPPAGELOGMODULE_H__9B03085A_360C_4477_9EA2_CACE129AA2C8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PropPageLogModule.h : header file
//

#include "WarIfLogModule.h"

/////////////////////////////////////////////////////////////////////////////
// CPropPageLogModule dialog

class CPropPageLogModule : public CPropertyPage
{
	DECLARE_DYNCREATE(CPropPageLogModule)

// Construction
public:
    CPropPageLogModule() {}
	CPropPageLogModule(war_if_log_module_ptr_t& logModulePtr);
	~CPropPageLogModule();

// Dialog Data
	//{{AFX_DATA(CPropPageLogModule)
	enum { IDD = IDD_PP_LOGMODULE };
	CStatic	m_ctlFileNameLabel;
	CEdit	m_ctlFileName;
	BOOL	m_bEnable;
	BOOL	m_bSystem;
	BOOL	m_bError;
	BOOL	m_bWarning;
	BOOL	m_bSecurity;
	BOOL	m_bInformative;
	BOOL	m_bLogin;
	BOOL	m_bLogout;
	BOOL	m_bAudit;
	BOOL	m_Upload;
	BOOL	m_bDownload;
	BOOL	m_bDeleteFile;
	BOOL	m_bCreateDir;
	BOOL	m_bDeleteDir;
	BOOL	m_bUserCreated;
	BOOL	m_bUserDeleted;
	BOOL	m_bUserChanged;
	BOOL	m_bNetwork;
	BOOL	m_bDbDebug;
	BOOL	m_bDbNetwork;
	BOOL	m_bDbFiles;
	BOOL	m_bDbThreads;
	BOOL	m_bDbCps;
	CString	m_FileNameLabel;
	CString	m_FileName;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPropPageLogModule)
	public:
	virtual BOOL OnApply();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPropPageLogModule)
	virtual BOOL OnInitDialog();
	afx_msg void OnEnable();
	afx_msg void OnChange();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
    war_if_log_module_ptr_t mLogModulePtr;
    void DoSetStates();

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PROPPAGELOGMODULE_H__9B03085A_360C_4477_9EA2_CACE129AA2C8__INCLUDED_)
