#if !defined(AFX_PROPPAGENTSTARTUP_H__B6192167_E59E_43A0_BF30_DD556D5A287B__INCLUDED_)
#define AFX_PROPPAGENTSTARTUP_H__B6192167_E59E_43A0_BF30_DD556D5A287B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PropPageNtStartup.h : header file
//

#include "WarIfServer.h"

/////////////////////////////////////////////////////////////////////////////
// CPropPageNtStartup dialog

class CPropPageNtStartup : public CPropertyPage
{
	DECLARE_DYNCREATE(CPropPageNtStartup)

// Construction
public:
    CPropPageNtStartup() {};
    CPropPageNtStartup(war_if_server_ptr_t& serverPtr);
	~CPropPageNtStartup();

// Dialog Data
	//{{AFX_DATA(CPropPageNtStartup)
	enum { IDD = IDD_PP_SERVER_STARTUP };
	BOOL	m_bRunAsNtService;
	BOOL	m_bAutostart;
	BOOL	m_bRunAsLocalSystem;
	CString	m_User;
	CString	m_Passwd;
	int		m_Priority;
	//}}AFX_DATA

    BOOL	m_bOrigRunAsNtService;
	BOOL	m_bOrigAutostart;
	BOOL	m_bOrigRunAsLocalSystem;
	CString	m_OrigUser;
	CString	m_OrigPasswd;


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPropPageNtStartup)
	public:
	virtual BOOL OnApply();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
    war_if_server_ptr_t mServerPtr;

	// Generated message map functions
	//{{AFX_MSG(CPropPageNtStartup)
	virtual BOOL OnInitDialog();
	afx_msg void OnNtService();
	afx_msg void OnBeSystem();
	afx_msg void OnChanged();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	void CheckForChanges();
	void EnableDisableControls();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PROPPAGENTSTARTUP_H__B6192167_E59E_43A0_BF30_DD556D5A287B__INCLUDED_)
