#if !defined(AFX_PROPPAGEOPTIONS_H__DDD8039E_5E5B_47F4_AA48_7132487A2AB8__INCLUDED_)
#define AFX_PROPPAGEOPTIONS_H__DDD8039E_5E5B_47F4_AA48_7132487A2AB8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PropPageOptions.h : header file
//

#include "WarIfOptions.h"

class WmsOption :
public WarIfOptions::option_def_t
{
public:
    CString mCurrentValue;
    bool mHaveValue;
};

/////////////////////////////////////////////////////////////////////////////
// CPropPageOptions dialog

class CPropPageOptions : public CPropertyPage
{
	DECLARE_DYNCREATE(CPropPageOptions)

// Construction
public:
    CPropPageOptions() {};
    CPropPageOptions(war_if_options_ptr_t optPtr, 
        const WarOption::OptLevelE optLevel);
	~CPropPageOptions();

// Dialog Data
	//{{AFX_DATA(CPropPageOptions)
	enum { IDD = IDD_PP_OPTIONS };
	CEdit	m_ctlValue;
	CEdit	m_ctlExplain;
	CListCtrl	m_ctlList;
	BOOL	m_bShowAll;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPropPageOptions)
	public:
	virtual BOOL OnApply();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
    war_if_options_ptr_t mOptPtr;
    WarOption::OptLevelE mOptLevel;
    static CImageList *mpImageList;
    bool mIsModified;

	// Generated message map functions
	//{{AFX_MSG(CPropPageOptions)
	virtual BOOL OnInitDialog();
	afx_msg void OnReset();
	afx_msg void OnItemchangedList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnShowAll();
	afx_msg void OnDblclkList(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void EnableDisableControls();
	void ReloadList();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PROPPAGEOPTIONS_H__DDD8039E_5E5B_47F4_AA48_7132487A2AB8__INCLUDED_)
