#if !defined(AFX_DLGSHARE_H__43D7E482_AB78_4A00_AFBA_94C0F1D6BD6E__INCLUDED_)
#define AFX_DLGSHARE_H__43D7E482_AB78_4A00_AFBA_94C0F1D6BD6E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DlgShare.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CPropPageShareLocation dialog

#include "WarSvrPath.h"

class CPropPageShareLocation : public CPropertyPage
{
// Construction
public:
    CPropPageShareLocation();
    ~CPropPageShareLocation();

// Dialog Data
	//{{AFX_DATA(CPropPageShareLocation)
	enum { IDD = IDD_PP_SHARE_LOCATION };
	CEdit	m_ctlUrl;
	CString	m_MountMoint;
	CString	m_Type;
	CString	m_Path;
	CString	m_Host;
	CString	m_UserName;
	CString	m_Password;
	//}}AFX_DATA

    WarSvrPath mPath; // The object we maintain ;)

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPropPageShareLocation)
    public:
	virtual BOOL OnApply();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CPropPageShareLocation)
	virtual BOOL OnInitDialog();
	afx_msg void OnChangeMountPoint();
	afx_msg void OnSelchangeType();
	afx_msg void OnChangePath();
	afx_msg void OnChangeHost();
	afx_msg void OnChangeUserName();
	afx_msg void OnChangePassword();
	afx_msg void OnBrowse();
	afx_msg void OnKillfocusType();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
    void RebuildUrl() throw(WarException);
    void UpdateUrl(LPCSTR str) throw(WarException);
    void UpdateUrlItem();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DLGSHARE_H__43D7E482_AB78_4A00_AFBA_94C0F1D6BD6E__INCLUDED_)
