/** 
*/

#ifndef SNAPIN_ABOUT_H
#define SNAPIN_ABOUT_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class CSnapinAbout : public ISnapinAbout
{
public:
    // LIFECYCLE
    CSnapinAbout();
    ~CSnapinAbout();
  
    // OPERATORS
    // OPERATIONS

    ///////////////////////////////
    // Interface IUnknown
    ///////////////////////////////
    STDMETHODIMP QueryInterface(REFIID riid, LPVOID *ppv);
    STDMETHODIMP_(ULONG) AddRef();
    STDMETHODIMP_(ULONG) Release();

     ///////////////////////////////
    // Interface ISnapinAbout
    ///////////////////////////////
    STDMETHODIMP GetSnapinDescription( 
    /* [out] */ LPOLESTR *lpDescription);
        
    STDMETHODIMP GetProvider( 
    /* [out] */ LPOLESTR *lpName);
        
    STDMETHODIMP GetSnapinVersion( 
    /* [out] */ LPOLESTR *lpVersion);
        
    STDMETHODIMP GetSnapinImage( 
    /* [out] */ HICON *hAppIcon);
        
    STDMETHODIMP GetStaticFolderImage( 
    /* [out] */ HBITMAP *hSmallImage,
    /* [out] */ HBITMAP *hSmallImageOpen,
    /* [out] */ HBITMAP *hLargeImage,
    /* [out] */ COLORREF *cMask);

    // CALLBACK
    // ACCESS
    // INQUIRY
    
protected:
private:
    ULONG				m_cref;
    HBITMAP				m_hSmallImage;
    HBITMAP				m_hLargeImage;
    HBITMAP				m_hSmallImageOpen;
    HICON				m_hAppIcon;

    HRESULT	AllocOleStr(LPOLESTR *lpDest, _TCHAR *szBuffer);
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* CSNAPIN_ABOUT_H_ */

