/** 
*/

#ifndef WMS_NODE_LOG_MODULES_H
#define WMS_NODE_LOG_MODULES_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef CDELEGATION_BASE_H
#   include "DelegationBase.h"
#endif

#ifndef WAR_IF_LOG_MODULE_H
#   include "WarIfLogModule.h"
#endif

#ifndef WAR_IF_SERVER_H
#   include "WarIfServer.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class WarIfServer;
class WarIfLogModule;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WmsNodeLogModules : public CDelegationBase
{
public:
    typedef std::list<war_if_log_module_ptr_t> logmod_list_t;
    // LIFECYCLE

    WmsNodeLogModules(war_if_server_ptr_t& rSvrPtr);
    ~WmsNodeLogModules();

    // OPERATORS
    // OPERATIONS
    // CALLBACK

    virtual HRESULT OnExpand(IConsoleNameSpace *pConsoleNameSpace, IConsole *pConsole, HSCOPEITEM parent);
    virtual HRESULT CreatePropertyPages(IPropertySheetCallback *lpProvider, LONG_PTR handle);
    virtual HRESULT HasPropertySheets() { return S_OK; }
    virtual HRESULT OnSelect(IConsole *pConsole, BOOL bScope, BOOL bSelect);
    virtual HRESULT OnShow(IConsole *pConsole, BOOL bShow, HSCOPEITEM scopeitem);

    // ACCESS
    // INQUIRY

    virtual const int GetBitmapIndex();
    virtual const _TCHAR *GetDisplayName(int nCol = 0);
    virtual const GUID& getNodeType();
    
protected:
private:
    war_if_server_ptr_t mServicePtr;
    static const GUID thisGuid;
    logmod_list_t mLogModules;

    void EnumerateLogModules();
    void ClearLogModules();

};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WMS_NODE_LOG_MODULES_H_ */

