#include "StdAfx.h"
#include "WarMmcSnapin.h"
#include "WmsNodeServerLogs.h"   // class implemented
#include "WarCollector.h"
#include "WarIfServer.h"


/////////////////////////////// PUBLIC ///////////////////////////////////////


// {03831573-B9E0-4e48-A321-2B65B5A78513}
const GUID WmsNodeServerLogs::thisGuid = 
{ 0x3831573, 0xb9e0, 0x4e48, { 0xa3, 0x21, 0x2b, 0x65, 0xb5, 0xa7, 0x85, 0x13 } };


WmsNodeServerLogs::WmsNodeServerLogs(war_if_server_ptr_t& rSvrPtr)
: mServicePtr(rSvrPtr) // Deleted by parent
{
}

WmsNodeServerLogs::~WmsNodeServerLogs()
{
}

//============================= LIFECYCLE ====================================
//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= CALLBACK     ===================================

HRESULT WmsNodeServerLogs::OnExpand(IConsoleNameSpace *pConsoleNameSpace, 
                                 IConsole *pConsole, 
                                 HSCOPEITEM parent)
{
    if (GetHandle() == NULL) 
        SetHandle((HANDLE)parent);

    if (!bExpanded) 
    {
    }
 
    return S_OK;   
}

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

const int WmsNodeServerLogs::GetBitmapIndex()
{
    return NICON_SERVER_LOG;
}

const _TCHAR *WmsNodeServerLogs::GetDisplayName(int nCol)
{
    static _TCHAR szDisplayName[256] = {0};
    
    if (!*szDisplayName)
    {
        LoadString(g_hinst, 
            IDS_SERVERLOGSNAME, 
            szDisplayName, 
            sizeof(szDisplayName));
    }
    
    return szDisplayName; 
}

const GUID & WmsNodeServerLogs::getNodeType()
{
    return thisGuid; 
}

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

