/** 
*/

#ifndef WMS_NODE_SERVICE_H
#define WMS_NODE_SERVICE_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef CDELEGATION_BASE_H
#   include "DelegationBase.h"
#endif

#ifndef WAR_IF_SERVER_H
#   include "WarIfServer.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class WarIfServer;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WmsNodeService : public CDelegationBase
{
public:
    // LIFECYCLE

    WmsNodeService(war_if_server_ptr_t& rSvrPtr);
    ~WmsNodeService();

    // OPERATORS
    // OPERATIONS
    // CALLBACK

    virtual HRESULT OnExpand(IConsoleNameSpace *pConsoleNameSpace, IConsole *pConsole, HSCOPEITEM parent);
    virtual HRESULT CreatePropertyPages(IPropertySheetCallback *lpProvider, LONG_PTR handle);
    virtual HRESULT HasPropertySheets() { return S_OK; }
    virtual HRESULT OnSelect(IConsole *pConsole, BOOL bScope, BOOL bSelect);
    virtual HRESULT OnToolbarCommand(CComponent *pComponent, IConsole *pConsole, MMC_CONSOLE_VERB verb);
    virtual HRESULT OnSetToolbar(CComponent *pComponent, IControlbar *pControlbar, IToolbar *pToolbar, BOOL bScope, BOOL bSelect);
    HRESULT OnUpdateToolbar(CComponent *pComponent);
    

    // ACCESS
    // INQUIRY

    virtual const int GetBitmapIndex();
    virtual const _TCHAR *GetDisplayName(int nCol = 0);
    virtual const GUID & getNodeType();
    
protected:
private:
    war_if_server_ptr_t mServicePtr;
    static const GUID thisGuid;

};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WMS_NODE_SERVICE_H_ */

