/** 
*/

#ifndef WMS_NODE_SITE_H
#define WMS_NODE_SITE_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef CDELEGATION_BASE_H
#   include "DelegationBase.h"
#endif

#ifndef WAR_IF_SITE_H
#   include "WarIfSite.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class WarIfServer;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WmsNodeSite : public CDelegationBase
{
public:
    // LIFECYCLE

    WmsNodeSite(war_if_site_ptr_t& rSitePtr);
    ~WmsNodeSite();

    // OPERATORS
    // OPERATIONS
    // CALLBACK

    virtual HRESULT OnExpand(IConsoleNameSpace *pConsoleNameSpace, IConsole *pConsole, HSCOPEITEM parent);
    virtual HRESULT CreatePropertyPages(IPropertySheetCallback *lpProvider, LONG_PTR handle);
    virtual HRESULT HasPropertySheets() { return S_OK; }
    virtual HRESULT OnSelect(IConsole *pConsole, BOOL bScope, BOOL bSelect);

    // ACCESS
    // INQUIRY

    virtual const int GetBitmapIndex();
    virtual const _TCHAR *GetDisplayName(int nCol = 0);
    virtual const GUID& getNodeType();
    
protected:
private:
    war_if_site_ptr_t mSitePtr;
    static const GUID thisGuid;

};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WMS_NODE_SITE_H_ */

