/* acconfig.h
   This file is in the public domain.
 
   Descriptive text for the C preprocessor macros that
   the distributed Autoconf macros can define.
   No software package will use all of them; autoheader copies the ones
   your configure.in uses into your configuration header file templates.
 
   The entries are in sort -df order: alphabetical, case insensitive,
   ignoring punctuation (such as underscores).  Although this order
   can split up related entries, it makes it easier to check whether
   a given entry is in the file.
 
   Leave the following blank line there!!  Autoheader needs it.  */

/* Linux operating system? */
#undef LINUX
 
/* Sun Solaris operating system */
#undef SOLARIS

/* Generic UNIX */
#undef UNIX

/* Program version */
#undef PACKAGE
 
/* Define if you have ptherads */
#undef THREAD_PTHREAD

/* Program version */
#undef VERSION

/* War library version */
#undef WARLIB_VERSION

/* Leave that blank line there!!  Autoheader needs it.
   If you're adding to this file, keep in mind:
   The entries are in sort -df order: alphabetical, case insensitive,
   ignoring punctuation (such as underscores).  */
