/** 
*/

#ifndef WAR_ESCAPE_STR_H
#define WAR_ESCAPE_STR_H

/* SYSTEM INCLUDES */

/* PROJECT INCLUDES */


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

template <class charT>
class WarEscapeStr : public std::basic_string<charT>
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarEscapeStr(const charT* from, const int escapeChar)
        : std::basic_string<charT>(from)
    {
        if ((NULL == from) || (0 == escapeChar))
            WarThrow(WarError(WAR_ERR_INVALID_ARGUMENT), NULL);

        if (find(escapeChar) != npos)
        {
            erase();
            for(const charT *p = from; *p; p++)
            {
                if (*p == escapeChar)
                    operator += (escapeChar);
                operator += (*p);
            }
        }
    }
    
    // OPERATORS
    // OPERATIONS                       
    // ACCESS
    // INQUIRY
    
protected:
private:
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_ESCAPE_STR_H_ */

