/** 
*/

#ifndef WAR_FSYS_H
#define WAR_FSYS_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_FILE_ENGINE_H
#   include "WarFileEngine.h"
#endif

#ifndef WAR_FILE_H
#   include "WarFile.h"
#endif

#ifndef WAR_FILE_ENUMS_H
#   include "WarFileEnums.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

/* INLINE METHODS */

inline void WarFsysStat(const WarUrl& fsysUrl, war_stat_t& st)
{
    WarFileEngine::GetEngine().GetDriver(
        fsysUrl.GetDriverName().c_str())->WarStat(
        fsysUrl, st);
}

inline WarFileEnums::FileTypeE WarFsysExamine(const WarUrl& fsysUrl, war_stat_t& st)
{
    return WarFileEngine::GetEngine().GetDriver(
        fsysUrl.GetDriverName().c_str())->WarExamine(
        fsysUrl, st);
}

inline void
WarFsysGetFileModTime(const WarUrl& fsysUrl,
                      WarTime& outTime,
                      size_t& outPrecision)
{
    WarFileEngine::GetEngine().GetDriver(
        fsysUrl.GetDriverName().c_str())->WarGetFileModTime(
        fsysUrl, outTime, outPrecision);
}

inline void WarFsysCreateDirectory(const WarUrl& fsysUrl)
{
    WarFileEngine::GetEngine().GetDriver(
        fsysUrl.GetDriverName().c_str())->WarCreateDirectory(
        fsysUrl);
}

inline const war_flen_t WarGetFreeSpaceOnPath(const WarUrl& fsysUrl)
{
    return WarFileEngine::GetEngine().GetDriver(
        fsysUrl.GetDriverName().c_str())->WarGetFreeSpaceOnPath(
        fsysUrl);
}


/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_FSYS_H_ */


