/** 
*/

#ifndef WAR_LOG_WIN32_NT_EVENT_HANDLER_H
#define WAR_LOG_WIN32_NT_EVENT_HANDLER_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */


#ifndef WAR_LOG_EVENT_HANDLER_H
#   include "WarLogEventHandler.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarLogWin32NtEventHandler : 
    public WarLogEventHandler
{
public:
    typedef TCHAR * str_t;

    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarLogWin32NtEventHandler(war_ccstr_t tag,
        const str_t name = NULL);
      
    /**
    * Destructor.
    */
    ~WarLogWin32NtEventHandler(void);
    
    // OPERATORS
    
    /**
    * Assignment operator.
    *
    * @param from THe value to assign to this object.
    *
    * @return A reference to this object.
    */
    WarLogWin32NtEventHandler& operator=(WarLogWin32NtEventHandler& from);
    
    // OPERATIONS                       
    // ACCESS
    // INQUIRY
    
protected:
    virtual void OnEvent(WarLogEvent& logEvent);

    virtual war_uint32_t GetDefaultEventMask();
    
private:
    HANDLE mEventlogHandle;
    HKEY mhKey;
    static const DWORD msEventMap[WARLOG_INVALID];
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_LOG_WIN32_NT_EVENT_HANDLER_H_ */

