/** 
 */

#ifndef WAR_OBJECT_GROUP_REF_H
#define WAR_OBJECT_GROUP_REF_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_PTR_WRAPPER_H
#   include "WarPtrWrapper.h"
#endif

#ifndef WAR_OBJECT_GROUP_H
#   include "WarObjectGroup.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarObjectGroupRef 
{
public:
    typedef WarPtrWrapper<WarObjectGroup> obj_wrap_t;
    
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarObjectGroupRef(WarObjectGroup *pRef)
        : mpRef(pRef)
    {
        if (pRef)
        {
#if WAR_CATCH_ALL
            try
#endif
            {
                pRef->AttachObject(this);
            }

#if WAR_CATCH_ALL            
            catch(...)
            {
                ; // Nothing
            }
#endif
        }

        return;
    }
        
    /**
    * Destructor.
    */
    ~WarObjectGroupRef(void)
    {   

#if WAR_CATCH_ALL
        try
#endif
        {
            if (mpRef)
                mpRef->DetachObject(this);
        }

#if WAR_CATCH_ALL        
        catch(...)
        {
            ; // Nothing
        }
#endif
    }
    
    // OPERATORS
    // OPERATIONS                       
    // ACCESS
    // INQUIRY
    
protected:
private:
    WarObjectGroup *mpRef;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* _WAR_OBJECT_GROUP_REF_H_ */

