


#include "stdafx.h"
#include <assert.h>

#include <iostream>

#include "WarPath.h"

using namespace std;


void TestWarPath()
{
    WarPath<wchar_t> mycpath("c:\\test");
    mycpath << "ing";

    cout << "Initial path is " << mycpath << endl;

    cout << "Filename is " << mycpath.GetFilename() << endl;
    cout << "Path name is " << mycpath.GetPathname() << endl;
    cout << "Mount path is " << mycpath.GetMountPath() << endl;

    mycpath.IsEmpty();
    mycpath.GetLength();

    mycpath.Reset();

    mycpath << "C:" 
        << WAR_SYSSLASH 
        << "test"
        << WAR_SYSSLASH 
        << "myfile.txt";

    cout << "Created path is '" << mycpath << "'" << endl;
    cout << "Filename is " << mycpath.GetFilename() << endl;
    cout << "Path name is " << mycpath.GetPathname() << endl;
    cout << "Extension is " << mycpath.GetExtension() << endl;

}

