
#include "stdafx.h"

#include <iostream>

#include "WarLog.h"
#include "WarLogIOStreamHandler.h"
#include "WarLogWin32NtEventHandler.h"

using namespace std;

void TestWin32NtEventlog()
{
    cout << "Testing WarLog and related classes" << endl;

    WarLogEngine log_engine;
    log_engine.InstallHandler(new WarLogIoStreamHandler(cout, "cout"));
    log_engine.InstallHandler(new WarLogWin32NtEventHandler("eventlog"));

    WarLog err_log(WARLOG_ERROR, "TestWarLog()");

    err_log << "Testing WARLOG_ERROR " 
        << WarError(WAR_ERR_SYSTEM_ERROR, 5) 
        << war_endl;
}

